
#ifndef __WHILEPROGS__INSTRUCTIONS_H
    #define __WHILEPROGS__INSTRUCTIONS_H


    #include <string>
    #include <map>
    #include <vector>


    class ExecutionContext
    {
        public:
            std::map<std::string, int> Variables;
    };



    class WhileInstruction;



    class WhileProgram
    {
        public:
            WhileProgram();
            ~WhileProgram();
            std::vector<WhileInstruction*> Instructions;
            void Execute(ExecutionContext* context);
    };



    class WhileInstruction
    {
        public:
            WhileInstruction();
            virtual ~WhileInstruction();
            virtual void Execute(ExecutionContext* context) = 0;
    };



    class WhileLoop : public WhileInstruction
    {
        public:
            WhileProgram* Block;
            std::string Variable;
            int CmpNumber;

            WhileLoop(std::string Variable, int CmpNumber, WhileProgram* Block);
            ~WhileLoop();
            virtual void Execute(ExecutionContext* context);
    };



    class Assignment : public WhileInstruction
    {
        public:
            std::string DstVariable;
            std::string SrcVariable;
            int Added;

            Assignment(std::string DstVariable, std::string SrcVariable, int Added);
            ~Assignment();
            virtual void Execute(ExecutionContext* context);
    };


#endif